Package | Class | Use | Tree | Deprecated | Index | Help
| log4jdbc3 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.log4jdbc
Class ResultSetSpy

    java.lang.Object
      net.sf.log4jdbc.ResultSetSpy

All Implemented Interfaces:
  ResultSet, Spy

public class ResultSetSpy
extends Object
implements ResultSet, Spy

Wraps a ResultSet and reports method calls, returns and exceptions.

Author:
  Arthur Blake

Field Summary
`static String` | `classTypeDescription` Description for ResultSet class type.

Fields inherited from interface java.sql.ResultSet
`CLOSE_CURSORS_AT_COMMIT, CONCUR_READ_ONLY, CONCUR_UPDATABLE, FETCH_FORWARD, FETCH_REVERSE, FETCH_UNKNOWN, HOLD_CURSORS_OVER_COMMIT, TYPE_FORWARD_ONLY, TYPE_SCROLL_INSENSITIVE, TYPE_SCROLL_SENSITIVE`

Constructor Summary
`ResultSetSpy(StatementSpy parent, ResultSet realResultSet)` Create a new ResultSetSpy that wraps another ResultSet object, that logs all method calls, expceptions, etc.

Method Summary
`boolean` | `absolute(int row)` Moves the cursor to the given row number in this `ResultSet` object.
`void` | `afterLast()` Moves the cursor to the end of this `ResultSet` object, just after the last row.
`void` | `beforeFirst()` Moves the cursor to the front of this `ResultSet` object, just before the first row.
`void` | `cancelRowUpdates()` Cancels the updates made to the current row in this `ResultSet` object.
`void` | `clearWarnings()` Clears all warnings reported on this `ResultSet` object.
`void` | `close()` Releases this `ResultSet` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed.
`void` | `deleteRow()` Deletes the current row from this `ResultSet` object and from the underlying database.
`int` | `findColumn(String columnName)` Maps the given `ResultSet` column name to its `ResultSet` column index.
`boolean` | `first()` Moves the cursor to the first row in this `ResultSet` object.
`Array` | `getArray(int i)` Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Array` object in the Java programming language.
`Array` | `getArray(String colName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Array` object in the Java programming language.
`InputStream` | `getAsciiStream(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of ASCII characters.
`InputStream` | `getAsciiStream(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of ASCII characters.
`BigDecimal` | `getBigDecimal(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.math.BigDecimal` with full precision.
`BigDecimal` | `getBigDecimal(int columnIndex, int scale)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.BigDecimal` in the Java programming language.
`BigDecimal` | `getBigDecimal(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.math.BigDecimal` with full precision.
`BigDecimal` | `getBigDecimal(String columnName, int scale)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.math.BigDecimal` in the Java programming language.
`InputStream` | `getBinaryStream(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a binary stream of uninterpreted bytes.
`InputStream` | `getBinaryStream(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of uninterpreted `byte`s.
`Blob` | `getBlob(int i)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Blob` object in the Java programming language.
`Blob` | `getBlob(String colName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Blob` object in the Java programming language.
`boolean` | `getBoolean(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `boolean` in the Java programming language.
`boolean` | `getBoolean(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `boolean` in the Java programming language.
`byte` | `getByte(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` in the Java programming language.
`byte` | `getByte(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` in the Java programming language.
`byte[]` | `getBytes(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` array in the Java programming language.
`byte[]` | `getBytes(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` array in the Java programming language.
`Reader` | `getCharacterStream(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.io.Reader` object.
`Reader` | `getCharacterStream(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.io.Reader` object.
`String` | `getClassType()` Get the type of class being spied upon.
`Clob` | `getClob(int i)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Clob` object in the Java programming language.
`Clob` | `getClob(String colName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Clob` object in the Java programming language.
`int` | `getConcurrency()` Retrieves the concurrency mode of this `ResultSet` object.
`int` | `getConnectionNumber()` Get the connection number.
`String` | `getCursorName()` Retrieves the name of the SQL cursor used by this `ResultSet` object.
`Date` | `getDate(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language.
`Date` | `getDate(int columnIndex, Calendar cal)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language.
`Date` | `getDate(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language.
`Date` | `getDate(String columnName, Calendar cal)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language.
`double` | `getDouble(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `double` in the Java programming language.
`double` | `getDouble(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `double` in the Java programming language.
`int` | `getFetchDirection()` Retrieves the fetch direction for this `ResultSet` object.
`int` | `getFetchSize()` Retrieves the fetch size for this `ResultSet` object.
`float` | `getFloat(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `float` in the Java programming language.
`float` | `getFloat(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `float` in the Java programming language.
`int` | `getInt(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as an `int` in the Java programming language.
`int` | `getInt(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as an `int` in the Java programming language.
`long` | `getLong(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `long` in the Java programming language.
`long` | `getLong(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `long` in the Java programming language.
`ResultSetMetaData` | `getMetaData()` Retrieves the number, types and properties of this `ResultSet` object's columns.
`Object` | `getObject(int columnIndex)` Gets the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language.
`Object` | `getObject(int i, Map map)` Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language.
`Object` | `getObject(String columnName)` Gets the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language.
`Object` | `getObject(String colName, Map map)` Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language.
`Ref` | `getRef(int i)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Ref` object in the Java programming language.
`Ref` | `getRef(String colName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Ref` object in the Java programming language.
`int` | `getRow()` Retrieves the current row number.
`short` | `getShort(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `short` in the Java programming language.
`short` | `getShort(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `short` in the Java programming language.
`Statement` | `getStatement()` Retrieves the `Statement` object that produced this `ResultSet` object.
`String` | `getString(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `String` in the Java programming language.
`String` | `getString(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `String` in the Java programming language.
`Time` | `getTime(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language.
`Time` | `getTime(int columnIndex, Calendar cal)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language.
`Time` | `getTime(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language.
`Time` | `getTime(String columnName, Calendar cal)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language.
`Timestamp` | `getTimestamp(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language.
`Timestamp` | `getTimestamp(int columnIndex, Calendar cal)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language.
`Timestamp` | `getTimestamp(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object.
`Timestamp` | `getTimestamp(String columnName, Calendar cal)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language.
`int` | `getType()` Retrieves the type of this `ResultSet` object.
`InputStream` | `getUnicodeStream(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as as a stream of two-byte Unicode characters.
`InputStream` | `getUnicodeStream(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of two-byte Unicode characters.
`URL` | `getURL(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.net.URL` object in the Java programming language.
`URL` | `getURL(String columnName)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.net.URL` object in the Java programming language.
`SQLWarning` | `getWarnings()` Retrieves the first warning reported by calls on this `ResultSet` object.
`void` | `insertRow()` Inserts the contents of the insert row into this `ResultSet` object and into the database.
`boolean` | `isAfterLast()` Retrieves whether the cursor is after the last row in this `ResultSet` object.
`boolean` | `isBeforeFirst()` Retrieves whether the cursor is before the first row in this `ResultSet` object.
`boolean` | `isFirst()` Retrieves whether the cursor is on the first row of this `ResultSet` object.
`boolean` | `isLast()` Retrieves whether the cursor is on the last row of this `ResultSet` object.
`boolean` | `last()` Moves the cursor to the last row in this `ResultSet` object.
`void` | `moveToCurrentRow()` Moves the cursor to the remembered cursor position, usually the current row.
`void` | `moveToInsertRow()` Moves the cursor to the insert row.
`boolean` | `next()` Moves the cursor down one row from its current position.
`boolean` | `previous()` Moves the cursor to the previous row in this `ResultSet` object.
`void` | `refreshRow()` Refreshes the current row with its most recent value in the database.
`boolean` | `relative(int rows)` Moves the cursor a relative number of rows, either positive or negative.
`protected void` | `reportAllReturns(String methodCall, String msg)` Report (for logging) that a method returned.
`protected void` | `reportException(String methodCall, SQLException exception)` Report an exception to be logged.
`protected void` | `reportReturn(String methodCall)` Conveniance method to report (for logging) that a method returned (void return type).
`protected boolean` | `reportReturn(String methodCall, boolean value)` Conveniance method to report (for logging) that a method returned a boolean value.
`protected byte` | `reportReturn(String methodCall, byte value)` Conveniance method to report (for logging) that a method returned a byte value.
`protected double` | `reportReturn(String methodCall, double value)` Conveniance method to report (for logging) that a method returned a double value.
`protected float` | `reportReturn(String methodCall, float value)` Conveniance method to report (for logging) that a method returned a float value.
`protected int` | `reportReturn(String methodCall, int value)` Conveniance method to report (for logging) that a method returned a int value.
`protected long` | `reportReturn(String methodCall, long value)` Conveniance method to report (for logging) that a method returned a long value.
`protected Object` | `reportReturn(String methodCall, Object value)` Conveniance method to report (for logging) that a method returned an Object.
`protected short` | `reportReturn(String methodCall, short value)` Conveniance method to report (for logging) that a method returned a short value.
`boolean` | `rowDeleted()` Retrieves whether a row has been deleted.
`boolean` | `rowInserted()` Retrieves whether the current row has had an insertion.
`boolean` | `rowUpdated()` Retrieves whether the current row has been updated.
`void` | `setFetchDirection(int direction)` Gives a hint as to the direction in which the rows in this `ResultSet` object will be processed.
`void` | `setFetchSize(int rows)` Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for this `ResultSet` object.
`void` | `updateArray(int columnIndex, Array x)` Updates the designated column with a `java.sql.Array` value.
`void` | `updateArray(String columnName, Array x)` Updates the designated column with a `java.sql.Array` value.
`void` | `updateAsciiStream(int columnIndex, InputStream x, int length)` Updates the designated column with an ascii stream value.
`void` | `updateAsciiStream(String columnName, InputStream x, int length)` Updates the designated column with an ascii stream value.
`void` | `updateBigDecimal(int columnIndex, BigDecimal x)` Updates the designated column with a `java.math.BigDecimal` value.
`void` | `updateBigDecimal(String columnName, BigDecimal x)` Updates the designated column with a `java.sql.BigDecimal` value.
`void` | `updateBinaryStream(int columnIndex, InputStream x, int length)` Updates the designated column with a binary stream value.
`void` | `updateBinaryStream(String columnName, InputStream x, int length)` Updates the designated column with a binary stream value.
`void` | `updateBlob(int columnIndex, Blob x)` Updates the designated column with a `java.sql.Blob` value.
`void` | `updateBlob(String columnName, Blob x)` Updates the designated column with a `java.sql.Blob` value.
`void` | `updateBoolean(int columnIndex, boolean x)` Updates the designated column with a `boolean` value.
`void` | `updateBoolean(String columnName, boolean x)` Updates the designated column with a `boolean` value.
`void` | `updateByte(int columnIndex, byte x)` Updates the designated column with a `byte` value.
`void` | `updateByte(String columnName, byte x)` Updates the designated column with a `byte` value.
`void` | `updateBytes(int columnIndex, byte[] x)` Updates the designated column with a `byte` array value.
`void` | `updateBytes(String columnName, byte[] x)` Updates the designated column with a byte array value.
`void` | `updateCharacterStream(int columnIndex, Reader x, int length)` Updates the designated column with a character stream value.
`void` | `updateCharacterStream(String columnName, Reader reader, int length)` Updates the designated column with a character stream value.
`void` | `updateClob(int columnIndex, Clob x)` Updates the designated column with a `java.sql.Clob` value.
`void` | `updateClob(String columnName, Clob x)` Updates the designated column with a `java.sql.Clob` value.
`void` | `updateDate(int columnIndex, Date x)` Updates the designated column with a `java.sql.Date` value.
`void` | `updateDate(String columnName, Date x)` Updates the designated column with a `java.sql.Date` value.
`void` | `updateDouble(int columnIndex, double x)` Updates the designated column with a `double` value.
`void` | `updateDouble(String columnName, double x)` Updates the designated column with a `double` value.
`void` | `updateFloat(int columnIndex, float x)` Updates the designated column with a `float` value.
`void` | `updateFloat(String columnName, float x)` Updates the designated column with a `float` value.
`void` | `updateInt(int columnIndex, int x)` Updates the designated column with an `int` value.
`void` | `updateInt(String columnName, int x)` Updates the designated column with an `int` value.
`void` | `updateLong(int columnIndex, long x)` Updates the designated column with a `long` value.
`void` | `updateLong(String columnName, long x)` Updates the designated column with a `long` value.
`void` | `updateNull(int columnIndex)` Gives a nullable column a null value.
`void` | `updateNull(String columnName)` Updates the designated column with a `null` value.
`void` | `updateObject(int columnIndex, Object x)` Updates the designated column with an `Object` value.
`void` | `updateObject(int columnIndex, Object x, int scale)` Updates the designated column with an `Object` value.
`void` | `updateObject(String columnName, Object x)` Updates the designated column with an `Object` value.
`void` | `updateObject(String columnName, Object x, int scale)` Updates the designated column with an `Object` value.
`void` | `updateRef(int columnIndex, Ref x)` Updates the designated column with a `java.sql.Ref` value.
`void` | `updateRef(String columnName, Ref x)` Updates the designated column with a `java.sql.Ref` value.
`void` | `updateRow()` Updates the underlying database with the new contents of the current row of this `ResultSet` object.
`void` | `updateShort(int columnIndex, short x)` Updates the designated column with a `short` value.
`void` | `updateShort(String columnName, short x)` Updates the designated column with a `short` value.
`void` | `updateString(int columnIndex, String x)` Updates the designated column with a `String` value.
`void` | `updateString(String columnName, String x)` Updates the designated column with a `String` value.
`void` | `updateTime(int columnIndex, Time x)` Updates the designated column with a `java.sql.Time` value.
`void` | `updateTime(String columnName, Time x)` Updates the designated column with a `java.sql.Time` value.
`void` | `updateTimestamp(int columnIndex, Timestamp x)` Updates the designated column with a `java.sql.Timestamp` value.
`void` | `updateTimestamp(String columnName, Timestamp x)` Updates the designated column with a `java.sql.Timestamp` value.
`boolean` | `wasNull()` Reports whether the last column read had a value of SQL `NULL`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### classTypeDescription

    public static final String classTypeDescription

  Description for ResultSet class type.

  See Also:
    Constant Field Values

Constructor Detail

### ResultSetSpy

    public ResultSetSpy(StatementSpy parent,
                        ResultSet realResultSet)

  Create a new ResultSetSpy that wraps another ResultSet object, that logs all method calls, expceptions, etc.

Parameters:
  `parent` - Statement that generated this ResultSet.
  `realResultSet` - real underlying ResultSet that is being wrapped.

Method Detail

### reportException

    protected void reportException(String methodCall,
                                   SQLException exception)

  Report an exception to be logged.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that generated the exception.
    `exception` - exception that was generated

### reportAllReturns

    protected void reportAllReturns(String methodCall,
                                    String msg)

  Report (for logging) that a method returned. All the other reportReturn methods are conveniance methods that call this method.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `msg` - description of what the return value that was returned. may be an empty String for void return types.

### getClassType

    public String getClassType()

  Description copied from interface: `Spy`
  Get the type of class being spied upon. For example, "Statement", "ResultSet", etc.

  Specified by:
    `getClassType` in interface `Spy`
  Returns:
    a description of the type of class being spied upon.

### getConnectionNumber

    public int getConnectionNumber()

  Description copied from interface: `Spy`
  Get the connection number. In general, this is used to track which underlying connection is being used from the database. The number will be incremented each time a new Connection is retrieved from the real underlying jdbc driver. This is useful for debugging and tracking down problems with connection pooling.

  Specified by:
    `getConnectionNumber` in interface `Spy`
  Returns:
    the connection instance number.

### reportReturn

    protected boolean reportReturn(String methodCall,
                                   boolean value)

  Conveniance method to report (for logging) that a method returned a boolean value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - boolean return value.
  Returns:
    the boolean return value as passed in.

### reportReturn

    protected byte reportReturn(String methodCall,
                                byte value)

  Conveniance method to report (for logging) that a method returned a byte value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - byte return value.
  Returns:
    the byte return value as passed in.

### reportReturn

    protected int reportReturn(String methodCall,
                               int value)

  Conveniance method to report (for logging) that a method returned a int value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - int return value.
  Returns:
    the int return value as passed in.

### reportReturn

    protected double reportReturn(String methodCall,
                                  double value)

  Conveniance method to report (for logging) that a method returned a double value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - double return value.
  Returns:
    the double return value as passed in.

### reportReturn

    protected short reportReturn(String methodCall,
                                 short value)

  Conveniance method to report (for logging) that a method returned a short value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - short return value.
  Returns:
    the short return value as passed in.

### reportReturn

    protected long reportReturn(String methodCall,
                                long value)

  Conveniance method to report (for logging) that a method returned a long value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - long return value.
  Returns:
    the long return value as passed in.

### reportReturn

    protected float reportReturn(String methodCall,
                                 float value)

  Conveniance method to report (for logging) that a method returned a float value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - float return value.
  Returns:
    the float return value as passed in.

### reportReturn

    protected Object reportReturn(String methodCall,
                                  Object value)

  Conveniance method to report (for logging) that a method returned an Object.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - return Object.
  Returns:
    the return Object as passed in.

### reportReturn

    protected void reportReturn(String methodCall)

  Conveniance method to report (for logging) that a method returned (void return type).

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.

### updateAsciiStream

    public void updateAsciiStream(int columnIndex,
                                  InputStream x,
                                  int length)
                           throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with an ascii stream value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateAsciiStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
    `length` - the length of the stream

### updateAsciiStream

    public void updateAsciiStream(String columnName,
                                  InputStream x,
                                  int length)
                           throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with an ascii stream value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateAsciiStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
    `length` - the length of the stream

### getRow

    public int getRow()
               throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the current row number. The first row is number 1, the second number 2, and so on.

  Specified by:
    `getRow` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    the current row number; `0` if there is no current row

### cancelRowUpdates

    public void cancelRowUpdates()
                          throws SQLException

  Description copied from interface: `ResultSet`
  Cancels the updates made to the current row in this `ResultSet` object. This method may be called after calling an updater method(s) and before calling the method `updateRow` to roll back the updates made to a row. If no updates have been made or `updateRow` has already been called, this method has no effect.

  Specified by:
    `cancelRowUpdates` in interface `ResultSet`
  Throws:
    `SQLException`

### getTime

    public Time getTime(int columnIndex)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language.

  Specified by:
    `getTime` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `null`

### getTime

    public Time getTime(String columnName)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language.

  Specified by:
    `getTime` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `null`

### getTime

    public Time getTime(int columnIndex,
                        Calendar cal)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the time if the underlying database does not store timezone information.

  Specified by:
    `getTime` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `cal` - the `java.util.Calendar` object to use in constructing the time
  Returns:
    the column value as a `java.sql.Time` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language

### getTime

    public Time getTime(String columnName,
                        Calendar cal)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the time if the underlying database does not store timezone information.

  Specified by:
    `getTime` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
    `cal` - the `java.util.Calendar` object to use in constructing the time
  Returns:
    the column value as a `java.sql.Time` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language

### absolute

    public boolean absolute(int row)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Moves the cursor to the given row number in this `ResultSet` object.

  If the row number is positive, the cursor moves to the given row number with respect to the beginning of the result set. The first row is row 1, the second is row 2, and so on.

  If the given row number is negative, the cursor moves to an absolute row position with respect to the end of the result set. For example, calling the method `absolute(-1)` positions the cursor on the last row; calling the method `absolute(-2)` moves the cursor to the next-to-last row, and so on.

  An attempt to position the cursor beyond the first/last row in the result set leaves the cursor before the first row or after the last row.

  Note: Calling `absolute(1)` is the same as calling `first()`. Calling `absolute(-1)` is the same as calling `last()`.

  Specified by:
    `absolute` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `row` - the number of the row to which the cursor should move. A positive number indicates the row number counting from the beginning of the result set; a negative number indicates the row number counting from the end of the result set
  Returns:
    `true` if the cursor is on the result set; `false` otherwise

### getTimestamp

    public Timestamp getTimestamp(int columnIndex)
                           throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language.

  Specified by:
    `getTimestamp` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `null`

### getTimestamp

    public Timestamp getTimestamp(String columnName)
                           throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object.

  Specified by:
    `getTimestamp` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `null`

### getTimestamp

    public Timestamp getTimestamp(int columnIndex,
                                  Calendar cal)
                           throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the timestamp if the underlying database does not store timezone information.

  Specified by:
    `getTimestamp` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `cal` - the `java.util.Calendar` object to use in constructing the timestamp
  Returns:
    the column value as a `java.sql.Timestamp` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language

### getTimestamp

    public Timestamp getTimestamp(String columnName,
                                  Calendar cal)
                           throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the timestamp if the underlying database does not store timezone information.

  Specified by:
    `getTimestamp` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
    `cal` - the `java.util.Calendar` object to use in constructing the date
  Returns:
    the column value as a `java.sql.Timestamp` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language

### moveToInsertRow

    public void moveToInsertRow()
                         throws SQLException

  Description copied from interface: `ResultSet`
  Moves the cursor to the insert row. The current cursor position is remembered while the cursor is positioned on the insert row. The insert row is a special row associated with an updatable result set. It is essentially a buffer where a new row may be constructed by calling the updater methods prior to inserting the row into the result set. Only the updater, getter, and `insertRow` methods may be called when the cursor is on the insert row. All of the columns in a result set must be given a value each time this method is called before calling `insertRow`. An updater method must be called before a getter method can be called on a column value.

  Specified by:
    `moveToInsertRow` in interface `ResultSet`
  Throws:
    `SQLException`

### relative

    public boolean relative(int rows)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Moves the cursor a relative number of rows, either positive or negative. Attempting to move beyond the first/last row in the result set positions the cursor before/after the the first/last row. Calling `relative(0)` is valid, but does not change the cursor position.

  Note: Calling the method `relative(1)` is identical to calling the method `next()` and calling the method `relative(-1)` is identical to calling the method `previous()`.

  Specified by:
    `relative` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `rows` - an `int` specifying the number of rows to move from the current row; a positive number moves the cursor forward; a negative number moves the cursor backward
  Returns:
    `true` if the cursor is on a row; `false` otherwise

### previous

    public boolean previous()
                     throws SQLException

  Description copied from interface: `ResultSet`
  Moves the cursor to the previous row in this `ResultSet` object.

  Specified by:
    `previous` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `true` if the cursor is on a valid row; `false` if it is off the result set

### moveToCurrentRow

    public void moveToCurrentRow()
                          throws SQLException

  Description copied from interface: `ResultSet`
  Moves the cursor to the remembered cursor position, usually the current row. This method has no effect if the cursor is not on the insert row.

  Specified by:
    `moveToCurrentRow` in interface `ResultSet`
  Throws:
    `SQLException`

### getRef

    public Ref getRef(int i)
               throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Ref` object in the Java programming language.

  Specified by:
    `getRef` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first column is 1, the second is 2, ...
  Returns:
    a `Ref` object representing an SQL `REF` value

### updateRef

    public void updateRef(int columnIndex,
                          Ref x)
                   throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Ref` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateRef` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### getRef

    public Ref getRef(String colName)
               throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Ref` object in the Java programming language.

  Specified by:
    `getRef` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `colName` - the column name
  Returns:
    a `Ref` object representing the SQL `REF` value in the specified column

### updateRef

    public void updateRef(String columnName,
                          Ref x)
                   throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Ref` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateRef` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### getBlob

    public Blob getBlob(int i)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Blob` object in the Java programming language.

  Specified by:
    `getBlob` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first column is 1, the second is 2, ...
  Returns:
    a `Blob` object representing the SQL `BLOB` value in the specified column

### updateBlob

    public void updateBlob(int columnIndex,
                           Blob x)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Blob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateBlob` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### getBlob

    public Blob getBlob(String colName)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Blob` object in the Java programming language.

  Specified by:
    `getBlob` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `colName` - the name of the column from which to retrieve the value
  Returns:
    a `Blob` object representing the SQL `BLOB` value in the specified column

### updateBlob

    public void updateBlob(String columnName,
                           Blob x)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Blob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateBlob` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### getClob

    public Clob getClob(int i)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Clob` object in the Java programming language.

  Specified by:
    `getClob` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first column is 1, the second is 2, ...
  Returns:
    a `Clob` object representing the SQL `CLOB` value in the specified column

### updateClob

    public void updateClob(int columnIndex,
                           Clob x)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Clob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateClob` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### getClob

    public Clob getClob(String colName)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Clob` object in the Java programming language.

  Specified by:
    `getClob` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `colName` - the name of the column from which to retrieve the value
  Returns:
    a `Clob` object representing the SQL `CLOB` value in the specified column

### updateClob

    public void updateClob(String columnName,
                           Clob x)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Clob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateClob` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### getBoolean

    public boolean getBoolean(int columnIndex)
                       throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `boolean` in the Java programming language.

  Specified by:
    `getBoolean` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `false`

### getBoolean

    public boolean getBoolean(String columnName)
                       throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `boolean` in the Java programming language.

  Specified by:
    `getBoolean` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `false`

### getArray

    public Array getArray(int i)
                   throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Array` object in the Java programming language.

  Specified by:
    `getArray` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first column is 1, the second is 2, ...
  Returns:
    an `Array` object representing the SQL `ARRAY` value in the specified column

### updateArray

    public void updateArray(int columnIndex,
                            Array x)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Array` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateArray` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### getArray

    public Array getArray(String colName)
                   throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Array` object in the Java programming language.

  Specified by:
    `getArray` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `colName` - the name of the column from which to retrieve the value
  Returns:
    an `Array` object representing the SQL `ARRAY` value in the specified column

### updateArray

    public void updateArray(String columnName,
                            Array x)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Array` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateArray` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### isBeforeFirst

    public boolean isBeforeFirst()
                          throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves whether the cursor is before the first row in this `ResultSet` object.

  Specified by:
    `isBeforeFirst` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `true` if the cursor is before the first row; `false` if the cursor is at any other position or the result set contains no rows

### getShort

    public short getShort(int columnIndex)
                   throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `short` in the Java programming language.

  Specified by:
    `getShort` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `0`

### getShort

    public short getShort(String columnName)
                   throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `short` in the Java programming language.

  Specified by:
    `getShort` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `0`

### getInt

    public int getInt(int columnIndex)
               throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as an `int` in the Java programming language.

  Specified by:
    `getInt` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `0`

### getInt

    public int getInt(String columnName)
               throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as an `int` in the Java programming language.

  Specified by:
    `getInt` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `0`

### close

    public void close()
               throws SQLException

  Description copied from interface: `ResultSet`
  Releases this `ResultSet` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed.

  Note: A `ResultSet` object is automatically closed by the `Statement` object that generated it when that `Statement` object is closed, re-executed, or is used to retrieve the next result from a sequence of multiple results. A `ResultSet` object is also automatically closed when it is garbage collected.

  Specified by:
    `close` in interface `ResultSet`
  Throws:
    `SQLException`

### getMetaData

    public ResultSetMetaData getMetaData()
                                  throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the number, types and properties of this `ResultSet` object's columns.

  Specified by:
    `getMetaData` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    the description of this `ResultSet` object's columns

### getType

    public int getType()
                throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the type of this `ResultSet` object. The type is determined by the `Statement` object that created the result set.

  Specified by:
    `getType` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`

### getDouble

    public double getDouble(int columnIndex)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `double` in the Java programming language.

  Specified by:
    `getDouble` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `0`

### getDouble

    public double getDouble(String columnName)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `double` in the Java programming language.

  Specified by:
    `getDouble` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `0`

### deleteRow

    public void deleteRow()
                   throws SQLException

  Description copied from interface: `ResultSet`
  Deletes the current row from this `ResultSet` object and from the underlying database. This method cannot be called when the cursor is on the insert row.

  Specified by:
    `deleteRow` in interface `ResultSet`
  Throws:
    `SQLException`

### getConcurrency

    public int getConcurrency()
                       throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the concurrency mode of this `ResultSet` object. The concurrency used is determined by the `Statement` object that created the result set.

  Specified by:
    `getConcurrency` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    the concurrency type, either `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`

### rowUpdated

    public boolean rowUpdated()
                       throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves whether the current row has been updated. The value returned depends on whether or not the result set can detect updates.

  Specified by:
    `rowUpdated` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `true` if both (1) the row has been visibly updated by the owner or another and (2) updates are detected
  See Also:
    `DatabaseMetaData.updatesAreDetected(int)`

### getDate

    public Date getDate(int columnIndex)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language.

  Specified by:
    `getDate` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `null`

### getDate

    public Date getDate(String columnName)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language.

  Specified by:
    `getDate` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `null`

### getDate

    public Date getDate(int columnIndex,
                        Calendar cal)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the date if the underlying database does not store timezone information.

  Specified by:
    `getDate` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `cal` - the `java.util.Calendar` object to use in constructing the date
  Returns:
    the column value as a `java.sql.Date` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language

### getDate

    public Date getDate(String columnName,
                        Calendar cal)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the date if the underlying database does not store timezone information.

  Specified by:
    `getDate` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column from which to retrieve the value
    `cal` - the `java.util.Calendar` object to use in constructing the date
  Returns:
    the column value as a `java.sql.Date` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language

### last

    public boolean last()
                 throws SQLException

  Description copied from interface: `ResultSet`
  Moves the cursor to the last row in this `ResultSet` object.

  Specified by:
    `last` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `true` if the cursor is on a valid row; `false` if there are no rows in the result set

### rowInserted

    public boolean rowInserted()
                        throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves whether the current row has had an insertion. The value returned depends on whether or not this `ResultSet` object can detect visible inserts.

  Specified by:
    `rowInserted` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `true` if a row has had an insertion and insertions are detected; `false` otherwise
  See Also:
    `DatabaseMetaData.insertsAreDetected(int)`

### rowDeleted

    public boolean rowDeleted()
                       throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves whether a row has been deleted. A deleted row may leave a visible "hole" in a result set. This method can be used to detect holes in a result set. The value returned depends on whether or not this `ResultSet` object can detect deletions.

  Specified by:
    `rowDeleted` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `true` if a row was deleted and deletions are detected; `false` otherwise
  See Also:
    `DatabaseMetaData.deletesAreDetected(int)`

### updateNull

    public void updateNull(int columnIndex)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Gives a nullable column a null value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateNull` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...

### updateNull

    public void updateNull(String columnName)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `null` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateNull` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column

### updateShort

    public void updateShort(int columnIndex,
                            short x)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `short` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateShort` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateShort

    public void updateShort(String columnName,
                            short x)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `short` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateShort` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### updateBoolean

    public void updateBoolean(int columnIndex,
                              boolean x)
                       throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `boolean` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateBoolean` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateBoolean

    public void updateBoolean(String columnName,
                              boolean x)
                       throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `boolean` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateBoolean` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### updateByte

    public void updateByte(int columnIndex,
                           byte x)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `byte` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateByte` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateByte

    public void updateByte(String columnName,
                           byte x)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `byte` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateByte` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### updateInt

    public void updateInt(int columnIndex,
                          int x)
                   throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with an `int` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateInt` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateInt

    public void updateInt(String columnName,
                          int x)
                   throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with an `int` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateInt` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### getObject

    public Object getObject(int columnIndex)
                     throws SQLException

  Description copied from interface: `ResultSet`

  Gets the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language.

  This method will return the value of the given column as a Java object. The type of the Java object will be the default Java object type corresponding to the column's SQL type, following the mapping for built-in types specified in the JDBC specification. If the value is an SQL `NULL`, the driver returns a Java `null`.

  This method may also be used to read database-specific abstract data types. In the JDBC 2.0 API, the behavior of method `getObject` is extended to materialize data of SQL user-defined types. When a column contains a structured or distinct value, the behavior of this method is as if it were a call to: `getObject(columnIndex, this.getStatement().getConnection().getTypeMap())`.

  Specified by:
    `getObject` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    a `java.lang.Object` holding the column value

### getObject

    public Object getObject(String columnName)
                     throws SQLException

  Description copied from interface: `ResultSet`

  Gets the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language.

  This method will return the value of the given column as a Java object. The type of the Java object will be the default Java object type corresponding to the column's SQL type, following the mapping for built-in types specified in the JDBC specification. If the value is an SQL `NULL`, the driver returns a Java `null`.

  This method may also be used to read database-specific abstract data types.

  In the JDBC 2.0 API, the behavior of the method `getObject` is extended to materialize data of SQL user-defined types. When a column contains a structured or distinct value, the behavior of this method is as if it were a call to: `getObject(columnIndex, this.getStatement().getConnection().getTypeMap())`.

  Specified by:
    `getObject` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    a `java.lang.Object` holding the column value

### getObject

    public Object getObject(int i,
                            Map map)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language. If the value is an SQL `NULL`, the driver returns a Java `null`. This method uses the given `Map` object for the custom mapping of the SQL structured or distinct type that is being retrieved.

  Specified by:
    `getObject` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first column is 1, the second is 2, ...
    `map` - a `java.util.Map` object that contains the mapping from SQL type names to classes in the Java programming language
  Returns:
    an `Object` in the Java programming language representing the SQL value

### getObject

    public Object getObject(String colName,
                            Map map)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language. If the value is an SQL `NULL`, the driver returns a Java `null`. This method uses the specified `Map` object for custom mapping if appropriate.

  Specified by:
    `getObject` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `colName` - the name of the column from which to retrieve the value
    `map` - a `java.util.Map` object that contains the mapping from SQL type names to classes in the Java programming language
  Returns:
    an `Object` representing the SQL value in the specified column

### next

    public boolean next()
                 throws SQLException

  Description copied from interface: `ResultSet`
  Moves the cursor down one row from its current position. A `ResultSet` cursor is initially positioned before the first row; the first call to the method `next` makes the first row the current row; the second call makes the second row the current row, and so on.

  If an input stream is open for the current row, a call to the method `next` will implicitly close it. A `ResultSet` object's warning chain is cleared when a new row is read.

  Specified by:
    `next` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `true` if the new current row is valid; `false` if there are no more rows

### updateLong

    public void updateLong(int columnIndex,
                           long x)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `long` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateLong` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateLong

    public void updateLong(String columnName,
                           long x)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `long` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateLong` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### updateFloat

    public void updateFloat(int columnIndex,
                            float x)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `float` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateFloat` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateFloat

    public void updateFloat(String columnName,
                            float x)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `float` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateFloat` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### updateDouble

    public void updateDouble(int columnIndex,
                             double x)
                      throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `double` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateDouble` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateDouble

    public void updateDouble(String columnName,
                             double x)
                      throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `double` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateDouble` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### getStatement

    public Statement getStatement()
                           throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the `Statement` object that produced this `ResultSet` object. If the result set was generated some other way, such as by a `DatabaseMetaData` method, this method returns `null`.

  Specified by:
    `getStatement` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    the `Statment` object that produced this `ResultSet` object or `null` if the result set was produced some other way

### updateString

    public void updateString(int columnIndex,
                             String x)
                      throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `String` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateString` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateString

    public void updateString(String columnName,
                             String x)
                      throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `String` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateString` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### getAsciiStream

    public InputStream getAsciiStream(int columnIndex)
                               throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of ASCII characters. The value can then be read in chunks from the stream. This method is particularly suitable for retrieving large LONGVARCHAR values. The JDBC driver will do any necessary conversion from the database format into ASCII.

  Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a getter method implicitly closes the stream. Also, a stream may return `0` when the method `InputStream.available` is called whether there is data available or not.

  Specified by:
    `getAsciiStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    a Java input stream that delivers the database column value as a stream of one-byte ASCII characters; if the value is SQL `NULL`, the value returned is `null`

### getAsciiStream

    public InputStream getAsciiStream(String columnName)
                               throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of ASCII characters. The value can then be read in chunks from the stream. This method is particularly suitable for retrieving large `LONGVARCHAR` values. The JDBC driver will do any necessary conversion from the database format into ASCII.

  Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a getter method implicitly closes the stream. Also, a stream may return `0` when the method `available` is called whether there is data available or not.

  Specified by:
    `getAsciiStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    a Java input stream that delivers the database column value as a stream of one-byte ASCII characters. If the value is SQL `NULL`, the value returned is `null`.

### updateBigDecimal

    public void updateBigDecimal(int columnIndex,
                                 BigDecimal x)
                          throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.math.BigDecimal` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateBigDecimal` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### getURL

    public URL getURL(int columnIndex)
               throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.net.URL` object in the Java programming language.

  Specified by:
    `getURL` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the index of the column 1 is the first, 2 is the second,...
  Returns:
    the column value as a `java.net.URL` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language

### updateBigDecimal

    public void updateBigDecimal(String columnName,
                                 BigDecimal x)
                          throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.BigDecimal` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateBigDecimal` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### getURL

    public URL getURL(String columnName)
               throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.net.URL` object in the Java programming language.

  Specified by:
    `getURL` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value as a `java.net.URL` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language

### updateBytes

    public void updateBytes(int columnIndex,
                            byte[] x)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `byte` array value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateBytes` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateBytes

    public void updateBytes(String columnName,
                            byte[] x)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a byte array value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateBytes` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### getUnicodeStream

    public InputStream getUnicodeStream(int columnIndex)
                                 throws SQLException

  Deprecated.

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as as a stream of two-byte Unicode characters. The first byte is the high byte; the second byte is the low byte. The value can then be read in chunks from the stream. This method is particularly suitable for retrieving large `LONGVARCHAR`values. The JDBC driver will do any necessary conversion from the database format into Unicode.

  Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a getter method implicitly closes the stream. Also, a stream may return `0` when the method `InputStream.available` is called, whether there is data available or not.

  Specified by:
    `getUnicodeStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    a Java input stream that delivers the database column value as a stream of two-byte Unicode characters; if the value is SQL `NULL`, the value returned is `null`

### getUnicodeStream

    public InputStream getUnicodeStream(String columnName)
                                 throws SQLException

  Deprecated.

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of two-byte Unicode characters. The first byte is the high byte; the second byte is the low byte. The value can then be read in chunks from the stream. This method is particularly suitable for retrieving large `LONGVARCHAR` values. The JDBC technology-enabled driver will do any necessary conversion from the database format into Unicode.

  Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a getter method implicitly closes the stream. Also, a stream may return `0` when the method `InputStream.available` is called, whether there is data available or not.

  Specified by:
    `getUnicodeStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    a Java input stream that delivers the database column value as a stream of two-byte Unicode characters. If the value is SQL `NULL`, the value returned is `null`.

### updateDate

    public void updateDate(int columnIndex,
                           Date x)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Date` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateDate` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateDate

    public void updateDate(String columnName,
                           Date x)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Date` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateDate` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### getFetchSize

    public int getFetchSize()
                     throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the fetch size for this `ResultSet` object.

  Specified by:
    `getFetchSize` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    the current fetch size for this `ResultSet` object
  See Also:
    `ResultSet.setFetchSize(int)`

### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the first warning reported by calls on this `ResultSet` object. Subsequent warnings on this `ResultSet` object will be chained to the `SQLWarning` object that this method returns.

  The warning chain is automatically cleared each time a new row is read. This method may not be called on a `ResultSet` object that has been closed; doing so will cause an `SQLException` to be thrown.

  Note: This warning chain only covers warnings caused by `ResultSet` methods. Any warning caused by `Statement` methods (such as reading OUT parameters) will be chained on the `Statement` object.

  Specified by:
    `getWarnings` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    the first `SQLWarning` object reported or `null` if there are none

### getBinaryStream

    public InputStream getBinaryStream(int columnIndex)
                                throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a binary stream of uninterpreted bytes. The value can then be read in chunks from the stream. This method is particularly suitable for retrieving large `LONGVARBINARY` values.

  Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a getter method implicitly closes the stream. Also, a stream may return `0` when the method `InputStream.available` is called whether there is data available or not.

  Specified by:
    `getBinaryStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    a Java input stream that delivers the database column value as a stream of uninterpreted bytes; if the value is SQL `NULL`, the value returned is `null`

### getBinaryStream

    public InputStream getBinaryStream(String columnName)
                                throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of uninterpreted `byte`s. The value can then be read in chunks from the stream. This method is particularly suitable for retrieving large `LONGVARBINARY` values.

  Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a getter method implicitly closes the stream. Also, a stream may return `0` when the method `available` is called whether there is data available or not.

  Specified by:
    `getBinaryStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    a Java input stream that delivers the database column value as a stream of uninterpreted bytes; if the value is SQL `NULL`, the result is `null`

### clearWarnings

    public void clearWarnings()
                       throws SQLException

  Description copied from interface: `ResultSet`
  Clears all warnings reported on this `ResultSet` object. After this method is called, the method `getWarnings` returns `null` until a new warning is reported for this `ResultSet` object.

  Specified by:
    `clearWarnings` in interface `ResultSet`
  Throws:
    `SQLException`

### updateTimestamp

    public void updateTimestamp(int columnIndex,
                                Timestamp x)
                         throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateTimestamp` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateTimestamp

    public void updateTimestamp(String columnName,
                                Timestamp x)
                         throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateTimestamp` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### first

    public boolean first()
                  throws SQLException

  Description copied from interface: `ResultSet`
  Moves the cursor to the first row in this `ResultSet` object.

  Specified by:
    `first` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `true` if the cursor is on a valid row; `false` if there are no rows in the result set

### getCursorName

    public String getCursorName()
                         throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the name of the SQL cursor used by this `ResultSet` object.

  In SQL, a result table is retrieved through a cursor that is named. The current row of a result set can be updated or deleted using a positioned update/delete statement that references the cursor name. To insure that the cursor has the proper isolation level to support update, the cursor's `SELECT` statement should be of the form `SELECT FOR UPDATE`. If `FOR UPDATE` is omitted, the positioned updates may fail.

  The JDBC API supports this SQL feature by providing the name of the SQL cursor used by a `ResultSet` object. The current row of a `ResultSet` object is also the current row of this SQL cursor.

  Note: If positioned update is not supported, a `SQLException` is thrown.

  Specified by:
    `getCursorName` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    the SQL name for this `ResultSet` object's cursor

### findColumn

    public int findColumn(String columnName)
                   throws SQLException

  Description copied from interface: `ResultSet`
  Maps the given `ResultSet` column name to its `ResultSet` column index.

  Specified by:
    `findColumn` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
  Returns:
    the column index of the given column name

### wasNull

    public boolean wasNull()
                    throws SQLException

  Description copied from interface: `ResultSet`
  Reports whether the last column read had a value of SQL `NULL`. Note that you must first call one of the getter methods on a column to try to read its value and then call the method `wasNull` to see if the value read was SQL `NULL`.

  Specified by:
    `wasNull` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `true` if the last column value read was SQL `NULL` and `false` otherwise

### updateBinaryStream

    public void updateBinaryStream(int columnIndex,
                                   InputStream x,
                                   int length)
                            throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a binary stream value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateBinaryStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
    `length` - the length of the stream

### updateBinaryStream

    public void updateBinaryStream(String columnName,
                                   InputStream x,
                                   int length)
                            throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a binary stream value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateBinaryStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
    `length` - the length of the stream

### getString

    public String getString(int columnIndex)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `String` in the Java programming language.

  Specified by:
    `getString` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `null`

### getString

    public String getString(String columnName)
                     throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `String` in the Java programming language.

  Specified by:
    `getString` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `null`

### getCharacterStream

    public Reader getCharacterStream(int columnIndex)
                              throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.io.Reader` object.

  Specified by:
    `getCharacterStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    a `java.io.Reader` object that contains the column value; if the value is SQL `NULL`, the value returned is `null` in the Java programming language.

### getCharacterStream

    public Reader getCharacterStream(String columnName)
                              throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.io.Reader` object.

  Specified by:
    `getCharacterStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
  Returns:
    a `java.io.Reader` object that contains the column value; if the value is SQL `NULL`, the value returned is `null` in the Java programming language

### setFetchDirection

    public void setFetchDirection(int direction)
                           throws SQLException

  Description copied from interface: `ResultSet`
  Gives a hint as to the direction in which the rows in this `ResultSet` object will be processed. The initial value is determined by the `Statement` object that produced this `ResultSet` object. The fetch direction may be changed at any time.

  Specified by:
    `setFetchDirection` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `direction` - an `int` specifying the suggested fetch direction; one of `ResultSet.FETCH_FORWARD`, `ResultSet.FETCH_REVERSE`, or `ResultSet.FETCH_UNKNOWN`
  See Also:
    `Statement.setFetchDirection(int)`, `ResultSet.getFetchDirection()`

### updateCharacterStream

    public void updateCharacterStream(int columnIndex,
                                      Reader x,
                                      int length)
                               throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a character stream value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateCharacterStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
    `length` - the length of the stream

### updateCharacterStream

    public void updateCharacterStream(String columnName,
                                      Reader reader,
                                      int length)
                               throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a character stream value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateCharacterStream` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `reader` - the `java.io.Reader` object containing the new column value
    `length` - the length of the stream

### getByte

    public byte getByte(int columnIndex)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` in the Java programming language.

  Specified by:
    `getByte` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `0`

### getByte

    public byte getByte(String columnName)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` in the Java programming language.

  Specified by:
    `getByte` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `0`

### updateTime

    public void updateTime(int columnIndex,
                           Time x)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Time` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateTime` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateTime

    public void updateTime(String columnName,
                           Time x)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with a `java.sql.Time` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateTime` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### getBytes

    public byte[] getBytes(int columnIndex)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` array in the Java programming language. The bytes represent the raw values returned by the driver.

  Specified by:
    `getBytes` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `null`

### getBytes

    public byte[] getBytes(String columnName)
                    throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` array in the Java programming language. The bytes represent the raw values returned by the driver.

  Specified by:
    `getBytes` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `null`

### isAfterLast

    public boolean isAfterLast()
                        throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves whether the cursor is after the last row in this `ResultSet` object.

  Specified by:
    `isAfterLast` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `true` if the cursor is after the last row; `false` if the cursor is at any other position or the result set contains no rows

### updateObject

    public void updateObject(int columnIndex,
                             Object x,
                             int scale)
                      throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with an `Object` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateObject` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value
    `scale` - for `java.sql.Types.DECIMA` or `java.sql.Types.NUMERIC` types, this is the number of digits after the decimal point. For all other types this value will be ignored.

### updateObject

    public void updateObject(int columnIndex,
                             Object x)
                      throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with an `Object` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateObject` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `x` - the new column value

### updateObject

    public void updateObject(String columnName,
                             Object x,
                             int scale)
                      throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with an `Object` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateObject` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value
    `scale` - for `java.sql.Types.DECIMAL` or `java.sql.Types.NUMERIC` types, this is the number of digits after the decimal point. For all other types this value will be ignored.

### updateObject

    public void updateObject(String columnName,
                             Object x)
                      throws SQLException

  Description copied from interface: `ResultSet`
  Updates the designated column with an `Object` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

  Specified by:
    `updateObject` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the name of the column
    `x` - the new column value

### getFetchDirection

    public int getFetchDirection()
                          throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the fetch direction for this `ResultSet` object.

  Specified by:
    `getFetchDirection` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    the current fetch direction for this `ResultSet` object
  See Also:
    `ResultSet.setFetchDirection(int)`

### getLong

    public long getLong(int columnIndex)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `long` in the Java programming language.

  Specified by:
    `getLong` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `0`

### getLong

    public long getLong(String columnName)
                 throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `long` in the Java programming language.

  Specified by:
    `getLong` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `0`

### isFirst

    public boolean isFirst()
                    throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves whether the cursor is on the first row of this `ResultSet` object.

  Specified by:
    `isFirst` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `true` if the cursor is on the first row; `false` otherwise

### insertRow

    public void insertRow()
                   throws SQLException

  Description copied from interface: `ResultSet`
  Inserts the contents of the insert row into this `ResultSet` object and into the database. The cursor must be on the insert row when this method is called.

  Specified by:
    `insertRow` in interface `ResultSet`
  Throws:
    `SQLException`

### getFloat

    public float getFloat(int columnIndex)
                   throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `float` in the Java programming language.

  Specified by:
    `getFloat` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `0`

### getFloat

    public float getFloat(String columnName)
                   throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `float` in the Java programming language.

  Specified by:
    `getFloat` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `0`

### isLast

    public boolean isLast()
                   throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves whether the cursor is on the last row of this `ResultSet` object. Note: Calling the method `isLast` may be expensive because the JDBC driver might need to fetch ahead one row in order to determine whether the current row is the last row in the result set.

  Specified by:
    `isLast` in interface `ResultSet`
  Throws:
    `SQLException`
  Returns:
    `true` if the cursor is on the last row; `false` otherwise

### setFetchSize

    public void setFetchSize(int rows)
                      throws SQLException

  Description copied from interface: `ResultSet`
  Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for this `ResultSet` object. If the fetch size specified is zero, the JDBC driver ignores the value and is free to make its own best guess as to what the fetch size should be. The default value is set by the `Statement` object that created the result set. The fetch size may be changed at any time.

  Specified by:
    `setFetchSize` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `rows` - the number of rows to fetch
  See Also:
    `ResultSet.getFetchSize()`

### updateRow

    public void updateRow()
                   throws SQLException

  Description copied from interface: `ResultSet`
  Updates the underlying database with the new contents of the current row of this `ResultSet` object. This method cannot be called when the cursor is on the insert row.

  Specified by:
    `updateRow` in interface `ResultSet`
  Throws:
    `SQLException`

### beforeFirst

    public void beforeFirst()
                     throws SQLException

  Description copied from interface: `ResultSet`
  Moves the cursor to the front of this `ResultSet` object, just before the first row. This method has no effect if the result set contains no rows.

  Specified by:
    `beforeFirst` in interface `ResultSet`
  Throws:
    `SQLException`

### getBigDecimal

    public BigDecimal getBigDecimal(int columnIndex,
                                    int scale)
                             throws SQLException

  Deprecated.

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.BigDecimal` in the Java programming language.

  Specified by:
    `getBigDecimal` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
    `scale` - the number of digits to the right of the decimal point
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `null`

### getBigDecimal

    public BigDecimal getBigDecimal(String columnName,
                                    int scale)
                             throws SQLException

  Deprecated.

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.math.BigDecimal` in the Java programming language.

  Specified by:
    `getBigDecimal` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the SQL name of the column
    `scale` - the number of digits to the right of the decimal point
  Returns:
    the column value; if the value is SQL `NULL`, the value returned is `null`

### getBigDecimal

    public BigDecimal getBigDecimal(int columnIndex)
                             throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.math.BigDecimal` with full precision.

  Specified by:
    `getBigDecimal` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnIndex` - the first column is 1, the second is 2, ...
  Returns:
    the column value (full precision); if the value is SQL `NULL`, the value returned is `null` in the Java programming language.

### getBigDecimal

    public BigDecimal getBigDecimal(String columnName)
                             throws SQLException

  Description copied from interface: `ResultSet`
  Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.math.BigDecimal` with full precision.

  Specified by:
    `getBigDecimal` in interface `ResultSet`
  Throws:
    `SQLException`
  Parameters:
    `columnName` - the column name
  Returns:
    the column value (full precision); if the value is SQL `NULL`, the value returned is `null` in the Java programming language.

### afterLast

    public void afterLast()
                   throws SQLException

  Description copied from interface: `ResultSet`
  Moves the cursor to the end of this `ResultSet` object, just after the last row. This method has no effect if the result set contains no rows.

  Specified by:
    `afterLast` in interface `ResultSet`
  Throws:
    `SQLException`

### refreshRow

    public void refreshRow()
                    throws SQLException

  Description copied from interface: `ResultSet`
  Refreshes the current row with its most recent value in the database. This method cannot be called when the cursor is on the insert row.

  The `refreshRow` method provides a way for an application to explicitly tell the JDBC driver to refetch a row(s) from the database. An application may want to call `refreshRow` when caching or prefetching is being done by the JDBC driver to fetch the latest value of a row from the database. The JDBC driver may actually refresh multiple rows at once if the fetch size is greater than one.

  All values are refetched subject to the transaction isolation level and cursor sensitivity. If `refreshRow` is called after calling an updater method, but before calling the method `updateRow`, then the updates made to the row are lost. Calling the method `refreshRow` frequently will likely slow performance.

  Specified by:
    `refreshRow` in interface `ResultSet`
  Throws:
    `SQLException`

Package | Class | Use | Tree | Deprecated | Index | Help
| log4jdbc3 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD